import java.io.*;

public class Ciphering extends CipheringDeciphering {

	protected int cipheredChar;   //Used for storing the derived ciphered character.
	protected int fileChar; //Used for storing the read character from the input file.
	protected int i = 0 ;  //A counting variable
	protected char keywordChar; //Used for storing 1 character from the keyword
	
	public String outputFilename;  //Output filename is constructed and stored in this variable

	//This is the constructor of this class
	public Ciphering(String filename, String keyword) throws FileNotFoundException,IOException{
		//The filename and keyword are first passed to the parent class's constructor
		super(filename, keyword);

		outputFilename = filename.substring(0, filename.length()-4) + "-Ciphered" +".txt";

		//Here, we setup the mechanism for storing the ciphered characters on disk
		fileOutStream =new FileOutputStream(outputFilename);
		outputWriter = new OutputStreamWriter(fileOutStream);
		bufWriter = new BufferedWriter(outputWriter);
	}
	
	public void cipher()throws FileNotFoundException,IOException{
		
		while( (fileChar = bufReader.read())!= -1){
			//1 character is read from the keyword. If that character was the last character of the keyword,
			//we loop back to the first character of the keyword.
			keywordChar = keywordArray[i];
			i++;
			if (i == keywordArray.length)
				i = 0;
			try{
				//In the following 2 lines, the ciphered character is found and written to disk.
				cipheredChar = table[fileChar][(int)(keywordChar)];
				bufWriter.write(cipheredChar);
			}catch(ArrayIndexOutOfBoundsException e){bufWriter.write(fileChar);};
		};
		System.out.println("\nThe operation has been successfully completed!\n");

		//After finishing the processing, the resources are released.
		bufReader.close();
		inputReader.close();
		fileInStream.close();

		bufWriter.close();
		outputWriter.close();
		fileOutStream.close();		
	}
}
