import java.io.*;

public class Deciphering extends CipheringDeciphering {

	protected int decipheredChar;  //A variable used for storing the deciphered character.
	protected int fileChar;  //A variable used for storing the read character from file.
	protected int row; // Indicating the row number of the Vigenere table
	protected int column; //Indicating the column number of the Vigenere table
	protected int i = 0 ; //A counting variable
	protected char keywordChar; //A variable used for storing 1 character from keyword
	
	public String outputFilename;   // Output filename is constructed and stored in this variable.

	//This is the constructor of this class
	public Deciphering(String filename, String keyword) throws FileNotFoundException,IOException{
		//The filename and keyword are passed to the constructor of parent class of this class.
		super(filename, keyword);

		outputFilename = filename.substring(0, filename.length()-4) + "-Deciphered" +".txt";

		//Setting up the mechanism by which we write to file.
		fileOutStream =new FileOutputStream(outputFilename);
		outputWriter = new OutputStreamWriter(fileOutStream);
		bufWriter = new BufferedWriter(outputWriter);
	}
	
	public void decipher()throws FileNotFoundException,IOException{
		
		while( (fileChar = bufReader.read())!= -1){
			//1 character is read from the keyword. If that character was the last character of the keyword,
			//we loop back to the first character of the keyword.
			keywordChar = keywordArray[i];
			i++;
			if (i == keywordArray.length)
				i = 0;

			//In deciphering, the keyword character indicates the column number.
			column = (int)keywordChar;
			//And then we search the found column for the file character. After finding it, 
			//we read the row number and then the deciphering is done.
			for (int x= 0 ; x <128 ; x++){
				if (table[x][column] == fileChar)
					row = x;
			}
			decipheredChar = row;
			//We write the deciphered character to file.
			bufWriter.write(decipheredChar);
		};
		System.out.println("\nThe operation has been successfully completed!\n");
		
		//We release the resources after finishing the operation.
		bufReader.close();
		inputReader.close();
		fileInStream.close();

		bufWriter.close();
		outputWriter.close();
		fileOutStream.close();		
	}
}
